[HDU 4747] Mex (线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4747

这道题是我去年刚入校队的时候参加网赛的题目。

一年过去了,我依然还是不会做。。

这是我难题计划的开始吧。。

竟然还敲挫了,自己真是弱。

题意:

给你一个数列a,定义Mex[L,R]为a[L,R]中没有出现过的最小的自然数。求1<=l<=r<=n的所有Mex[l,r]之和。

解法我也是看了解题报告才知道的。

请参看cxlove大神的博文:http://blog.csdn.net/acm_cxlove/article/details/11749383

代码:

 1 #include <cstdio>
 2 #include <cstring>
 3 #include <algorithm>
 4 #include <set>
 5 using namespace std;
 6
 7 typedef long long LL;
 8 typedef pair<int,int> PII;
 9 const int MAX_N = 2e5+100;
10 LL delta[MAX_N<<2],sum[MAX_N<<2],maxn[MAX_N<<2];
11 PII b[MAX_N];
12 int a[MAX_N],next[MAX_N],n;
13 set<int> Set;
14
15 void push_down(int idx,int l,int r){
16     if( delta[idx]!=-1 ){
17         int m = l+r>>1;
18         sum[idx<<1] = (m-l+1)*delta[idx];
19         sum[idx<<1|1] = (r-m)*delta[idx];
20         delta[idx<<1] = delta[idx<<1|1] = maxn[idx<<1] = maxn[idx<<1|1] = delta[idx];
21         delta[idx] = -1;
22     }
23 }
24
25 void push_up(int idx){
26     sum[idx] = sum[idx<<1]+sum[idx<<1|1];
27     maxn[idx] = max(maxn[idx<<1],maxn[idx<<1|1]);
28 }
29
30 void update(int L,int R,LL x,int idx,int l,int r){
31     if( R<l||L>r ) return;
32     if( L<=l&&R>=r ) {
33         sum[idx]  = (r-l+1)*x;
34         maxn[idx] = delta[idx] = x;
35         return;
36     }
37     push_down(idx,l,r);
38     int m = l+r>>1;
39     if( L<=m ) update(L,R,x,idx<<1,l,m);
40     if( R>m ) update(L,R,x,idx<<1|1,m+1,r);
41     push_up(idx);
42 }
43
44 int query(LL x,int idx,int l,int r){
45     if( maxn[idx]<=x ) return r+1;
46     if( l==r ) return l;
47     push_down(idx,l,r);
48     int m = l+r>>1;
49     if( maxn[idx<<1]>x ) return query(x,idx<<1,l,m);
50     else return query(x,idx<<1|1,m+1,r);
51 }
52
53 LL querySum(int L,int R,int idx,int l,int r){
54     if( L<=l&&R>=r ) return sum[idx];
55     push_down(idx,l,r);
56     int m = l+r >> 1 ;
57     LL res = 0;
58     if( L<=m ) res =  querySum(L,R,idx<<1,l,m);
59     if( R>m ) res += querySum(L,R,idx<<1|1,m+1,r);
60     return res;
61 }
62
63 int main(){
64     while(scanf("%d",&n)!=EOF&&n){
65         memset(sum,0,sizeof(sum));
66         memset(delta,-1,sizeof(delta));
67         Set.clear();
68         for(int i=1;i<=n;i++){
69             scanf("%d",&a[i]);
70             b[i] = PII(a[i],i);
71             next[i] = n+1;
72         }
73         sort(b+1,b+1+n);
74         b[n+1].first = b[n].first; b[n+1].second = n+1;
75         for(int i=1;i<=n;i++){
76             if( b[i].first==b[i+1].first ) next[b[i].second] = b[i+1].second;
77         }
78         int mmex = 0;
79         for(int i=1;i<=n;i++){
80             Set.insert(a[i]);
81             while( Set.find(mmex)!=Set.end() ) mmex++;
82             update(i,i,mmex,1,1,n);
83         }
84         LL ans = sum[1];
85         for (int l = 1; l <= n; l++) {
86             update(l,l,0,1,1,n);
87             int p = query(a[l],1,1,n);
88             p = max(l+1,p);
89             int q = next[l] - 1;
90             update(p,q,a[l],1,1,n);
91             ans += sum[1];
92         }
93         printf("%I64d\n", ans);
94     }
95     return 0;
96 }
时间: 2024-10-12 23:06:47

[HDU 4747] Mex (线段树)的相关文章

hdu 4747 Mex( 线段树? 不,区间处理就行(dp?))

Mex Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)Total Submission(s): 3056    Accepted Submission(s): 1006 Problem Description Mex is a function on a set of integers, which is universally used for impartial game

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

HDU 1828 Picture 线段树+扫描线

题意:给你一些矩形的左上角点的坐标和右下角点的坐标,求周长并 最显而易见的思路就是对于x轴和y轴做两次扫描线,对于负数的坐标进行离散化.每次增加的值是线段变化量的绝对值.具体写法和求面积并的差不多. #include <cstdio> #include <algorithm> #include <cstring> #include <vector> using namespace std; #define lson rt << 1 , l , m

HDU 1542 Atlantis(线段树扫描线)

http://acm.hdu.edu.cn/showproblem.php?pid=1542 Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6788    Accepted Submission(s): 2970 Problem Description There are several ancient Greek

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我

hdu 1542 Atlantis(线段树&amp;扫描线&amp;面积并)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6386    Accepted Submission(s): 2814 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i

hdu 1828 Picture(线段树&amp;扫描线&amp;周长并)

Picture Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2578    Accepted Submission(s): 1363 Problem Description A number of rectangular posters, photographs and other pictures of the same shap

hdu 1542 Atlantis(线段树)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6899    Accepted Submission(s): 3022 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i

hdu 4864(2) 线段树

对task和machine的yi由小到大进行排序,然后对machine来跟task配对.当machine[].yi >= task[].yi时,就更新线段树,在1-1440上做线段树,线段树存的是task[].xi,同时用用优先队列保存task[].yi:当machine[].yi < task[].yi时,就查找 1到machine[].xi最大的值.如果存在最大值的话,把优先队列里的task[].yi取出来..这样一个machine就匹配到了一个最优的任务.还是看代码好好意会吧,细节挺多的

HDU 1166(线段树单点更新)

HDU 1166 题意:1-n个堡垒,人数在不断变化,多次查询 l-r人数和: 思路:线段树的单点更新: #include<iostream> #include<cstring> #include<cstdio> #include<string> #include<algorithm> #include<cmath> #include<map> #include<vector> #include<queu